package com.blackledge.david.html;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

public class HTMLRow {
	public static final int ROW_ALIGN_CENTER = 0;
	public static final int ROW_ALIGN_RIGHT = 1;
	public static final int ROW_ALIGN_LEFT = -1;
	
	//FIXME finish this
	public static final int ROW_BG_POSITION_CENTER_TOP = 50000;
	public static final int ROW_BG_POSITION_CENTER_CENTER = 50050;
	public static final int ROW_BG_POSITION_CENTER_BOTTOM = 50100;
	public static final int ROW_BG_POSITION_LEFT_TOP = 0;
	public static final int ROW_BG_POSITION_LEFT_CENTER = 50;
	public static final int ROW_BG_POSITION_LEFT_BOTTOM = 100;
	public static final int ROW_BG_POSITION_RIGHT_TOP = 100000;
	public static final int ROW_BG_POSITION_RIGHT_CENTER = 100050;
	public static final int ROW_BG_POSITION_RIGHT_BOTTOM = 100100;
	public static final int ROW_BG_POSITION_DEFAULT = ROW_BG_POSITION_LEFT_TOP;
	
	public static final int ROW_BG_REPEAT_NONE = 0;
	public static final int ROW_BG_REPEAT_BOTH = 3;
	public static final int ROW_BG_REPEAT_X = 1;
	public static final int ROW_BG_REPEAT_Y = 2;
	public static final int ROW_BG_REPEAT_DEFAULT = ROW_BG_REPEAT_BOTH;

	private List<HTMLChunk> chunks = new ArrayList<HTMLChunk>();
	public int align = ROW_ALIGN_LEFT;
	public Color bgcolor = null;
	public String bg = null;
	public int bgrepeat = -1;
	public int bgposition = -1;
	
	public void setBGProps(Integer repeat, Integer position) {
		bgrepeat = repeat;
		bgposition = position;
	}

	@Override
	public String toString() {
		StringBuffer buffer = new StringBuffer();
		for(HTMLChunk chunk : chunks) {
			buffer.append(chunk.toString());
		}
		return buffer.toString();
	}
	
	public List<HTMLChunk> getHTMLChunks() {
		synchronized (chunks) {
			return chunks;
		}
	}

	public void add(HTMLChunk chunk) {
		synchronized(chunks) {
			chunks.add(chunk);
		}
	}

	/**
	 * reduce the number of chunks by merging their contents when they are of
	 * like kinds.
	 */
	public void mergeChunks() {
		synchronized (chunks) {
			if (chunks.size() < 2)
				return;
			boolean didMerge = false;
			ArrayList<HTMLChunk> mergedChunks = new ArrayList<HTMLChunk>();
			HTMLTextChunk lastChunk = null;
			for (HTMLChunk chunk : chunks) {
				if (chunk instanceof HTMLTextChunk) {
					HTMLTextChunk thisChunk = (HTMLTextChunk) chunk;
if(thisChunk.anchor != null)debugOut("merging includes anchor "+thisChunk.anchor);
					if (lastChunk == null) {
						lastChunk = thisChunk;
					} else if (thisChunk.sameStyleAs(lastChunk) 
//							// make sure we can save the anchor, it's important! ;]
//							&& (lastChunk.anchor == null || lastChunk.anchor.equals(thisChunk.anchor))
							// make sure we save the anchor, it's important! ;]
							&& thisChunk.anchor == null
							// make a reasonable limit for a single row
							&& lastChunk.text.length() < 200) {
						lastChunk.text += thisChunk.text;
//						if(lastChunk.anchor == null) {
//							// save the anchor!
//							lastChunk.anchor = thisChunk.anchor;
//						}
						didMerge = true;
					} else {
						mergedChunks.add(lastChunk);
						lastChunk = thisChunk;
					}
				} else {
					if (lastChunk != null) {
						mergedChunks.add(lastChunk);
					}
					mergedChunks.add(chunk);
					lastChunk = null;
				}
			}
			if (lastChunk != null) {
				mergedChunks.add(lastChunk);
			}
			if (didMerge) {
				chunks.clear();
				chunks.addAll(mergedChunks);
			}
		}		
	}

	private void debugOut(Object msg) {
		System.out.println(msg);
	}

}
