package com.blackledge.david.html.hme;

import java.net.URL;

import com.blackledge.david.html.HTMLImageChunk;

import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.IHmeEventHandler;
import com.tivo.hme.sdk.IHmeProtocol;
import com.tivo.hme.sdk.Resource;
import com.tivo.hme.sdk.StreamResource;

/**
 * Handle an image so we can deal with redirect errors, record its dimensions
 * (or permanent error) for future requests. We didn't have to pause rendering
 * for this one, though.
 */
final class AsynchronousInlineImageResourceHandler extends BlockingInlineImageResourceHandler implements
			IHmeEventHandler {
		AsynchronousInlineImageResourceHandler(HTMLBreakdown htmlBreakdown, HTMLImageChunk chunk,
				BView view, URL urlBase) {
			super(htmlBreakdown, chunk, view, urlBase);
		}
		
		@Override
		protected void applyNewResource(Resource res) {
			if(res != null && res instanceof StreamResource && ((StreamResource)res).getURI() != null) {
				WebBrowserApp.debugOut("replacing resource with "+((StreamResource)res).getURI());
			}
			else
				WebBrowserApp.debugOut("replacing resource with "+res);
			
			//FIXME refactor...copied from HTMLBreakdown and could become more complex in the future.
			_view.setResource(res 
// FIXME no, stretch the image as specified	(have to set scale, and make other adjustments)	
					, IHmeProtocol.RSRC_IMAGE_BESTFIT
					| IHmeProtocol.RSRC_HALIGN_LEFT // mainly for error text or image
					| IHmeProtocol.RSRC_VALIGN_TOP // mainly for error text or image
					| IHmeProtocol.RSRC_TEXT_WRAP // for error text
					); // FIXME add alignment to chunk and here.			
//			view.setResource(errorResource,
//			ResourceInfo.RSRC_TEXT_WRAP
//			| ResourceInfo.RSRC_HALIGN_LEFT
//			| ResourceInfo.RSRC_VALIGN_TOP
//			| ResourceInfo.RSRC_IMAGE_BESTFIT);
		}

		protected void finishedWithResource(HmeEvent event) {
			WebBrowserApp.debugOut("finished with resource, removing handler of "+event.getID());
			// we're done with status, remove ourselves.
			Resource res = _view.getBApp().getResource(event.getID());
			if(res != null) {
				res.removeHandler(this);
			}
			// don't "continuerender" on htmlbreakdown...we weren't paused...we're asynchronous

			// we placed the updated resource elsewhere
		}
	}