package com.blackledge.david.html.hme;

import java.net.URL;
import java.util.List;

import com.blackledge.david.html.HTMLRow;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;
import com.tivo.hme.sdk.View;

public class BRowView extends BView {

	public int rowIndex = -1;
	private BRowBGView bgView;
	private boolean isBGTopOwner = false;

	public BRowView(BView parent, int x, int y, int width, int height,
			boolean visible) {
		super(parent, x, y, width, height, visible);
	}

	public BRowView(BView parent, int x, int y, int width, int height) {
		super(parent, x, y, width, height);
	}

	public boolean isBGTopOwner() {
		return isBGTopOwner;
	}
	
	@Override
	public void setLocation(int x, int y) {
//		if(isBGTopOwner() && bgView != null) {
////			WebBrowserApp.debugOut("move bg to "+x+","+y);
//			bgView.setLocation(x, y);
//		}
		super.setLocation(x, y);
		if(bgView != null) {
			bgView.updateHeight(null);
		}
	}
	
	@Override
	public void setLocation(int x, int y, Resource animation) {
//		if(isBGTopOwner() && bgView != null) {
////			WebBrowserApp.debugOut("move bg to "+x+","+y+","+animation);
//			bgView.setLocation(x, y, animation);
//		}
		super.setLocation(x, y, animation);
		if(bgView != null) {
			bgView.updateHeight(animation);
		}
	}
	
	@Override
	public void setSize(int width, int height) {
//		if(isBGTopOwner() && bgView != null) {
//			WebBrowserApp.debugOut("size bg to "+width+","+height);
//			bgView.setSize(width, height);
//		}
		super.setSize(width, height);
		if(bgView != null) {
			WebBrowserApp.debugOut("resized row to "+width+","+height);
			bgView.updateHeight(null);
		}
	}
	
	@Override
	public void setSize(int width, int height, Resource animation) {
//		if(isBGTopOwner() && bgView != null) {
//			WebBrowserApp.debugOut("size bg to "+width+","+height+","+animation);
//			bgView.setSize(width, height, animation);
//		}
		super.setSize(width, height, animation);
		if(bgView != null) {
			WebBrowserApp.debugOut("resized row to "+width+","+height);
			bgView.updateHeight(animation);
		}
	}
	
	@Override
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		if(bgView != null) {
			bgView.updateHeight(null);
		}
	}
	
	@Override
	public void setBounds(int x, int y, int width, int height,
			Resource animation) {
		super.setBounds(x, y, width, height, animation);
		if(bgView != null) {
			bgView.updateHeight(animation);
		}
	}
	
	@Override
	public void remove() {
		removeBG();
		//FIXME remove resource, too?
		super.remove();
	}
	
	@Override
	public void remove(Resource animation) {
		removeBG();
		//FIXME remove resource, too?
		super.remove(animation);
	}
	

	private void removeBG() {
		if(bgView != null) {
			BRowView newOwner = this.bgView.removeRow(this);
			if(isBGTopOwner()) {
				//need to transfer ownership of the bgView
				if(newOwner != null) {
					newOwner.isBGTopOwner = true;
					if(newOwner.bgView != this.bgView) {
						WebBrowserApp.debugOut("!!! umm... bgView wasn't shared by two rows that should be sharing it!");
					}
				} else {
					// nobody left... need to remove the bgView, too
					this.bgView.remove();
				}
			}
		}
	}

	public void setBG(List<HTMLRow> rows, int htmlRowIndex, URL baseURL) {
		//FIXME add sanity checks
		HTMLRow row = rows.get(htmlRowIndex);
		BRowView prevRowView = getRowView(this.rowIndex-1, this.getParent());
		if(prevRowView != null && prevRowView.bgView != null) {
			HTMLRow prevRow = rows.get(htmlRowIndex-1);
			if(prevRow != null && isEqual(prevRow.bg, row.bg) && isEqual(prevRow.bgcolor, row.bgcolor)) {
//				WebBrowserApp.debugOut("!!!stretch down "+row.bg+" "+row.bgcolor);
				this.bgView = prevRowView.bgView;
				this.bgView.addRow(this);
				return;
			}
		}
		BRowView nextRowView = getRowView(this.rowIndex+1, this.getParent());
		if(nextRowView != null && nextRowView.bgView != null) {
			HTMLRow nextRow = rows.get(htmlRowIndex+1);
			if(nextRow != null && isEqual(nextRow.bg, row.bg) && isEqual(nextRow.bgcolor, row.bgcolor)) {
//				WebBrowserApp.debugOut("!!!stretch up "+row.bg+" "+row.bgcolor);
				this.bgView = nextRowView.bgView;
				this.bgView.addRow(this);
				this.isBGTopOwner = true;
				nextRowView.isBGTopOwner = false;
				return;
			}
		}
		// only set bg if base bg shouldn't just shine through.
		if(!((BRowViewParent) this.getParent()).isBGSameAsRowParent(baseURL, row.bgcolor, row.bg)) {
			this.bgView = new BRowBGView(((BRowViewParent) this.getParent()).getBGParent(), this.getX(), this.getY(), this.getWidth(), this.getHeight());
			this.bgView.addRow(this);
			this.isBGTopOwner = true;
			this.bgView.setBG(baseURL, row.bg, row.bgcolor, row.bgrepeat, row.bgposition);

//						WebBrowserApp.debugOut("SET "+row.getClass().getCanonicalName()+" "+row.bgcolor+" "+row.bg );
//									+ " over "+((BRowViewParent) this.getParent()).bgcolor+" "+((BRowViewParent) this.getParent()).bg);
		}
//		else 			WebBrowserApp.debugOut("PASS THROUGH "+row.getClass().getCanonicalName()+" "+row.bgcolor+" "+row.bg);
		
	}
	
	private boolean isEqual(Object bg, Object bg2) {
		if(bg == null && bg2 == null) return true;
		if(bg != null && bg2 != null && bg.equals(bg2)) return true;
		return false;
	}

	private BRowView getRowView(int targetIndex, View pageArea) {
		for(int i = 0 ; i < pageArea.getChildCount() ; ++i) {
			if(pageArea.getChild(i) instanceof BRowView) {
				BRowView child = ((BRowView)pageArea.getChild(i));
				int index = child.rowIndex;
				if(index == targetIndex) {
					return child;
				}
			}
		}
		return null;
	}

}