package com.blackledge.david.html.hme;

import java.awt.Color;
import java.net.URL;

import com.blackledge.david.html.HTMLTableCell;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

/**
 * BView to hold html rows as well as the parent of their backgrounds
 * @author David
 *
 */
public class BRowViewParent extends BView {

	private BView bgParent;
	private String bg;
	private Color bgcolor;
	private URL baseURL;

	public static BRowViewParent newInstance(BView parent, int x,
			int y, int width, int height) {
		return newInstance(parent, x, y, width, height, null);
	}
	public static BRowViewParent newInstance(BView parent, int x,
			int y, int width, int height, BView bgparent) {
		if(bgparent == null)
			bgparent = new BView(parent, x, y, width, height);
		BRowViewParent instance = new BRowViewParent(parent, x, y, width, height);
//		BView bgp = instance;
//		BView bgp = new BView(instance, 0, 0, width, height);
		
		instance.bgParent = bgparent;
		return instance;
	}

	private BRowViewParent(BView parent, int x, int y, int width,
			int height) {
		super(parent, x, y, width, height);
		
	}

	public BView getBGParent() {
		return this.bgParent;
	}
	
	@Override
	public void setLocation(int x, int y) {
		super.setLocation(x, y);
		this.bgParent.setLocation(x, y);
	}

	@Override
	public void setLocation(int x, int y, Resource animation) {
		super.setLocation(x, y, animation);
		this.bgParent.setLocation(x, y, animation);
	}
	
	@Override
	public void setSize(int width, int height) {
		super.setSize(width, height);
		this.bgParent.setSize(width, height);
	}
	
	@Override
	public void setSize(int width, int height, Resource animation) {
		super.setSize(width, height, animation);
		this.bgParent.setSize(width, height, animation);
	}
	
	@Override
	public void setBounds(int x, int y, int width, int height) {
		super.setBounds(x, y, width, height);
		this.bgParent.setBounds(x, y, width, height);
//		this.bgParent.setBounds(0,0, width, height);
	}
	
	@Override
	public void setBounds(int x, int y, int width, int height,
			Resource animation) {
		super.setBounds(x, y, width, height, animation);
		this.bgParent.setBounds(x, y, width, height, animation);
//		this.bgParent.setBounds(0,0, width, height, animation);
	}

	public void setRowParentBG(URL baseURL, HTMLTableCell chunk) {
		if(((BRowViewParent)
				this.getParent() // table row
				.getParent()) // BRowViewParent
				.isBGSameAsRowParent(baseURL, chunk.bgcolor, chunk.bg)) {
//			WebBrowserApp.debugOut("PASS THROUGH cell "+chunk.bgcolor+" "+chunk.bg);
			// just let cell's parent shine through
		} else {
			WebBrowserApp.debugOut("SET cell "+chunk.bgcolor+" "+chunk.bg + " over "+((BRowViewParent)getParent().getParent()).bgcolor+" "+((BRowViewParent)getParent().getParent()).bg);
			setRowParentBG(baseURL, chunk.bgcolor, chunk.bg, chunk.bgposition, chunk.bgrepeat);
		}
	}
	
	public boolean isBGSameAsRowParent(URL baseURL, Color bgcolor, String bg) {
		URL imgUrl = null;
		URL thisImgUrl = null;
		try {
			if(baseURL != null && bg != null) {
				imgUrl = URLConnectionHandler.getURL(baseURL, bg);
			}
		} catch (Exception e) {
		}
		try {
			if(this.baseURL != null && this.bg != null) {
				thisImgUrl = URLConnectionHandler.getURL(this.baseURL, this.bg);
			}
		} catch (Exception e) {
		}
		
		if(thisImgUrl == null && this.bgcolor == null) {
			// need to compare with this parent's parent.
			if(this.getParent() instanceof BRowViewParent) {
				// not sure this case can ever happen.
				return ((BRowViewParent) this.getParent()).isBGSameAsRowParent(baseURL, bgcolor, bg);
			} else if(this.getParent().getParent() instanceof BRowViewParent) {
				return ((BRowViewParent) this.getParent().getParent()).isBGSameAsRowParent(baseURL, bgcolor, bg);
			} else if(this.getParent().getParent().getParent() instanceof BRowViewParent) {
				return ((BRowViewParent) this.getParent().getParent().getParent()).isBGSameAsRowParent(baseURL, bgcolor, bg);
			}

//			just fall through... we'll be returning false unless both are all null
		}
		if(imgUrl != null && !imgUrl.equals(thisImgUrl)) return false;
		// ignore color if bg is set and did match
		if(imgUrl == null && bgcolor != null && !bgcolor.equals(this.bgcolor)) return false;
		return true;
	}
	
	public void setRowParentBG(URL baseURL, Color bgcolor, String bg, int bgposition, int bgrepeat) {
		this.baseURL = baseURL; this.bgcolor = bgcolor; this.bg = bg;
		if(bgcolor != null) {
			this.bgParent.setResource(bgcolor);
			if(bg != null) {
				try {
					BView bgView = new BView(this.bgParent, 0, 0,
							this.bgParent.getWidth(), this.bgParent.getHeight());
					HTMLBreakdown.setupInlineBackground(bgView, baseURL, bg, bgposition, bgrepeat);
//					URL bgu = new URL(bg);
//					Resource bgResource = bgView.getResource(bgu);
//					bgResource.addHandler(new InlineBackgroundResourceHandler(
//							bgView, bgu, bgResource, bgrepeat,
//							bgposition));
//					bgView.setResource(bgResource);
				} catch (Exception e) {
					// should just be a url error which we'll just pretend there wasn't a url.
				}
			}
		} else if(bg != null) {
			try {
				BView bgView = this.bgParent;
//			new BView(this.bgParent, 0, 0,
//			this.bgParent.getWidth(), this.bgParent.getHeight());
				HTMLBreakdown.setupInlineBackground(bgView, baseURL, bg, bgposition, bgrepeat);
//				URL bgu = new URL(bg);
//				Resource bgResource = bgView.getResource(bgu);
//				bgResource.addHandler(new InlineBackgroundResourceHandler(
//						bgView, bgu, bgResource, bgrepeat,
//						bgposition));
//				bgView.setResource(bgResource);
			} catch (Exception e) {
				// should just be a url error which we'll just pretend there wasn't a url.
			}
		}
	}

}
