package com.blackledge.david.html.hme;

import java.awt.Color;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Properties;

import com.almilli.tivo.bananas.hd.CustomSkin;

import com.tivo.hme.bananas.BHighlight;
import com.tivo.hme.bananas.BSkin;
import com.tivo.hme.bananas.BSkin.Element;
import com.tivo.hme.sdk.IHmeProtocol;
import com.tivo.hme.sdk.ImageResource;

public class WebBrowserTheme {

	private CustomSkin hdSkin;
	private WebBrowserApp webBrowserApp;
	private URL themeURL;
	private CustomSkin sdSkin;

	public WebBrowserTheme(WebBrowserApp webBrowserApp, URL themeURL) {
		this.webBrowserApp = webBrowserApp;
		this.themeURL = themeURL;
		if(this.themeURL != null) {
			loadThemeDefinition(this.themeURL);
		}
		
		prepareSDSkin();
		prepareHDSkin();
	}

	private void loadThemeDefinition(URL url) {
		try {
			InputStream themeStream = url.openStream();
		} catch (IOException e) {
			WebBrowserApp.debugOut("Error Loading Theme "+url+": "+e);
		}
	}

	private void prepareHDSkin() {
		// setSkin(new BResSkin(this, "com/tivo/hme/bananas/images720/"));
		// setSkin(new BResSkin(this, "com/almilli/tivo/bananas/hd/images/"));
		hdSkin = new CustomSkin(this.webBrowserApp);
		// boolean highDef = getHeight() > 480;
		// if (highDef) {
		// String prefix =
		// HDApplication.class.getPackage().getName().replace('.', '/') +
		// "/images/";
		String prefix = "com/almilli/tivo/bananas/hd/images/"; //$NON-NLS-1$

		// add the highlight bar
		Properties props = new Properties();
		props.put("cap", "50"); //$NON-NLS-1$ //$NON-NLS-2$
		props.put("padh", "25"); //$NON-NLS-1$ //$NON-NLS-2$
		props.put("padv", "4"); //$NON-NLS-1$ //$NON-NLS-2$
		
//		String properties = "" +
//				"		cap=50\r\n" + 
//				"		padh=25\r\n" + 
//				"		padv=4\r\n";
//		StringReader inReader = new StringReader(properties);
//		try {
//			props.load(inReader);
//		} catch (IOException e) {
//		}
		
		hdSkin.add(BHighlight.H_BAR
				, 1280, 60, prefix + "bar_hd.png", props); //$NON-NLS-1$

		// add the keyboard highlight
		hdSkin.add(BHighlight.H_KEYBOARD
				, 144, 100, prefix + "keyboard-focus.png"); //$NON-NLS-1$

		// add the arrows
		hdSkin.add(BHighlight.H_UP
				, 48, 40, prefix + "up_hd.png"); //$NON-NLS-1$
		hdSkin.add(BHighlight.H_DOWN
				, 48, 40, prefix + "down_hd.png"); //$NON-NLS-1$
		hdSkin.add(BHighlight.H_LEFT
				, 35, 30, prefix + "left_hd.png"); //$NON-NLS-1$
		hdSkin.add(BHighlight.H_RIGHT
				, 35, 30, prefix + "right_hd.png"); //$NON-NLS-1$
//		hdSkin.add("showcases", 0, 0, "purple1.png");
//		hdSkin.add("nowplaying", 0, 0, "green1.png");
//		hdSkin.add("setup", 0, 0, "blue1.png");
//		hdSkin.add("showcases", 0, 0, "tivo_stars_3-8.png");
//		hdSkin.add("nowplaying", 0, 0, "hd_background-grey.png");
//		hdSkin.add("setup", 0, 0, "tivo_stars_2-8.png");
// replace with URL instead of inline to speed up response time (no synchronous download)
//		hdSkin.add("showcases", 0, 0, "com/blackledge/david/html/hme/bg/hd/tivohdpurple.png");
		hdSkin.add("showcases", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/hd/tivohdpurple.png");
		hdSkin.add("nowplaying", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/hd/tivohdgreen.png");
		hdSkin.add("setup", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/hd/tivohdblue.png");
		hdSkin.add("central", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/hd/tivohdred.png");
//		hdSkin.add("scroll_bar", 0, 0, "0x2222CC");
//		hdSkin.add("scroll_bg", 0, 0, "0x222222");
		hdSkin.add("scroll_bar", 60, 1080, "scroll_bar.png");
		hdSkin.add("scroll_bg", 60, 1080, "scroll_bg.png");
		// }
	}
	
	private void prepareSDSkin() {
		BSkin baseSkin = new BSkin(webBrowserApp);
		sdSkin = new CustomSkin(webBrowserApp);
		String skinEntries[] = new String[]{};
		for(String entry : skinEntries) {
			Element e = baseSkin.get(entry);
			//FIXME convert e.getProperties map to a Properties
			// passing null causes BSkin.get to fill in based on the name.
			((CustomSkin) sdSkin).add(e.getName(), e.getWidth(), e.getHeight(), null);
		}
//		sdSkin.add("showcases", 0, 0, "purple1.png");
//		sdSkin.add("nowplaying", 0, 0, "green1.png");
//		sdSkin.add("setup", 0, 0, "blue1.png");
//		sdSkin.add("showcases", 0, 0, "sd_background-grey.png");
//		sdSkin.add("nowplaying", 0, 0, "sd_background-grey.png");
//		sdSkin.add("setup", 0, 0, "sd_background-grey.png");
		sdSkin.add("showcases", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/sd/tivosdpurple.png");
		sdSkin.add("nowplaying", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/sd/tivosdgreen.png");
		sdSkin.add("setup", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/sd/tivosdblue.png");
		sdSkin.add("central", 0, 0, "http://david.blackledge.com/tivo/enterwebz/bg/sd/tivosdred.png");
//		sdSkin.add("scroll_bar", 0, 0, "0x2222CC");
//		sdSkin.add("scroll_bg", 0, 0, "0x222222");
		sdSkin.add("scroll_bar", 60, 1080, "scroll_bar.png");
		sdSkin.add("scroll_bg", 60, 1080, "scroll_bg.png");
	}

	public BSkin getHDSkin() {
		return hdSkin;
	}
	
	public BSkin getSDSkin() {
		return sdSkin;
	}

	/**
	 * @return String to use as a resource
	 */
	public String getPleaseWait() {
		return "please_wait.gif";
	}
	
	/**
	 * @return String to use as a resource
	 */
	public String getFolderIcon(String genre) {
		if(genre != null) {
			if(genre.equalsIgnoreCase("video")) {
				return "icon-video-folder.png";
			} else if(genre.equalsIgnoreCase("music")) {
				return "icon-music-folder.png";
			} else if(genre.equalsIgnoreCase("photos")) {
				return "icon-photos-folder.png";
			}
		}
		return "icon-folder.png";
	}

	public String getIcon(String genre) {
		if(genre != null) {
			if(genre.equalsIgnoreCase("video")) {
				return "icon-video.png";
			} else if(genre.equalsIgnoreCase("music")) {
				return "icon-music.png";
			} else if(genre.equalsIgnoreCase("photos")) {
				return "icon-photos.png";
			}
		}
		return "icon.png";
	}

	/**
	 * @return String to use as a resource
	 */
	public String getPageSaved() {
//		return "bookmark.png";
		return "ThumbsUpOn.png";
	}
	
	/**
	 * @return String to use as a resource
	 */
	public String getPageNotSaved() {
//		return "0xFFFFFF";
		return "ThumbsUpOff.png";
	}

	/**
	 * @return String to use as a resource
	 */
	public String getLogo() {
//		return "0x440044";
		return "moon-8.png";
	}
	
	/**
	 * @return String to use as a resource
	 */
	public String getPrefChecked() {
//		return "bookmark.png";
		return "check_checked.png";
	}
	
	/**
	 * @return String to use as a resource
	 */
	public String getPrefUnchecked() {
		return null;
	}

	/**
	 * @return String to use as a resource
	 */
	public String getPrefCheckedRadio() {
		//TODO get a real radio image
		return "check_checked.png";
	}
	
	/**
	 * @return String to use as a resource
	 */
	public String getPrefUncheckedRadio() {
		//TODO get a real radio empty image
		// radio using check for uncheck (with transparency)
		return "check_checked.png";
	}

	/**
	 * @return String to use as a resource
	 */
	public String getProgress(WebBrowserApp.STATUS status) {
		Color color = Color.green;
		switch(status) {
		case CONNECTING:
		case CONNECTING_STREAM:
//			return "radio_unchecked.png";
			color = Color.yellow;
			break;
		case PARSING:
		case PARSING_XML:
		case PARSING_CSS:
		case PARSING_HTML:
//			return "radio_checked.png";
			color = Color.blue;	
			break;
		case REDIRECTING:
//			return "check_unchecked.png";
			color = Color.orange;
			break;
		case COMPLETE:
//			return "check_checked.png";
			color = Color.green;
			break;
		}
		
		String hexString = Integer.toHexString(color.getRGB());
		// pad to 6 chars.
		hexString = "000000"+hexString;
		hexString = hexString.substring(hexString.length()-6);
		return "0x"+hexString;
	}
	
	public static enum FORM {BUTTON, SELECT, INPUT, CHECKBOX, RADIO};
	/**
	 * @return resource value to use (either a string or a resource from a named highlight)
	 */
	public Object getFormResource(FORM form) {
		switch (form) {
		case BUTTON: {
			String highlight = BHighlight.H_BAR;
			Element barSkin = getBApp().getSkin().get(highlight);
			return barSkin.getResource();
		}
		case SELECT: {
			String highlight = BHighlight.H_BAR;
			Element barSkin = getBApp().getSkin().get(highlight);
			return barSkin.getResource();
		}
		case INPUT:
			return "com/tivo/hme/bananas/keyboard-datafield.png";
		case CHECKBOX:
			return "com/blackledge/david/html/hme/check_bg_hd.png";
		case RADIO:
			return "com/blackledge/david/html/hme/radio_bg_hd.png";
//		case CHECKBOX:
//		case RADIO: {
//			return null;
////			String highlight = BHighlight.H_KEYBOARD;
////			Element barSkin = getBApp().getSkin().get(highlight);
////			return barSkin.getResource();
//		}
		}
		return null;
	}
	/**
	 * @return null or resource value to use (either a string or a resource from a named highlight)
	 */
	public Object getFormDetailResource(FORM form, boolean checked) {
		switch (form) {
		case BUTTON: {
			return null;
		}
		case SELECT: {
			String highlight = BHighlight.H_PAGEDOWN;
			Element barSkin = getBApp().getSkin().get(highlight);
			return barSkin.getResource();
		}
		case INPUT:
			return null;
		case CHECKBOX:
			if(checked)
			return "com/blackledge/david/html/hme/check_checked_hd.png";
			else return null;
		case RADIO:
			if(checked)
			return "com/blackledge/david/html/hme/radio_checked_hd.png";
			else return null;
			
//		case CHECKBOX: {
//			if(checked) return "check_checked.png";
//			else return "check_unchecked.png";
////			if(!checked) return "0x999999";
////			String highlight = BHighlight.H_PAGEUP;
////			Element barSkin = getBApp().getSkin().get(highlight);
////			return barSkin.getResource();
//		}
//		case RADIO: {
//			if(checked) return "radio_checked.png";
//			else return "radio_unchecked.png";
////			if(!checked) return "0x999999";
////			String highlight = BHighlight.H_UP;
////			Element barSkin = getBApp().getSkin().get(highlight);
////			return barSkin.getResource();
//		}
		}
		return null;
	}
	/**
	 * @return 6 array entries: widthoffset heightoffset rightoffset leftoffset upoffset downoffset
	 */
	public int[] getFormOffsets(FORM form) {
		switch(form) {
		case BUTTON:
			return new int[] {20, 10, 10, -10, -10, 10};
		case SELECT:
			return new int[] {26, 10, 10, -10, -10, 10};
		case INPUT:
			return new int[] {20, 10, 10, -10, -10, 10};
		case CHECKBOX:
		case RADIO:
			return new int[] {0, 0, 10, -10, -10, 10};
		}
		return null;
	}
	/**
	 * @return null or 5 array entries: xoffset yoffset widthoffset heightoffset alignbits (rsrc_h/valign values)
	 */
	public int[] getFormDetailOffsets(FORM form, boolean checked) {
		switch(form) {
		case BUTTON:
		case INPUT:
			return null;
		case SELECT:
			return new int[] {0, 0, -6, 0, IHmeProtocol.RSRC_HALIGN_RIGHT | IHmeProtocol.RSRC_VALIGN_CENTER}; // 36
		case CHECKBOX:
		case RADIO:
			// take up full space
			return new int[] {0, 1, 0, -2, IHmeProtocol.RSRC_HALIGN_CENTER | IHmeProtocol.RSRC_VALIGN_CENTER}; // 36
//			// take up space within main resource's center
//			return new int[] {1, 2, -2, -4, IHmeProtocol.RSRC_HALIGN_CENTER | IHmeProtocol.RSRC_VALIGN_CENTER}; // 36
//			// take up space within main resource's center
//			return new int[] {2, 5, -4, -10, IHmeProtocol.RSRC_HALIGN_CENTER | IHmeProtocol.RSRC_VALIGN_CENTER}; // 36
		}
		return null;
	}
	/**
	 * @return 4 array entries: xoffset, yoffset, widthoffset, heightoffset
	 */
	public int[] getFormLabelOffsets(FORM form) {
		switch(form) {
		case BUTTON:
			return new int[] {10, 5, -20, -10};
		case SELECT:
			return new int[] {10, 6, -26, -10};
		case INPUT:
			return new int[] {10, 5, -20, -10};
		case CHECKBOX:
		case RADIO:
			return new int[] {0, 0, 0, 0};
		}
		return null;
	}

	private WebBrowserApp getBApp() {
		return webBrowserApp;
	}

	/**
	 * @return null or resource value to use (either a string or a resource from a named highlight)
	 */
	public Object getFormDetailResource(FORM form) {
		return getFormDetailResource(form, false);
	}
	
	/**
	 * @return null or 5 array entries: xoffset yoffset widthoffset heightoffset alignbits (rsrc_h/valign values)
	 */
	public int[] getFormDetailOffsets(FORM form) {
		return getFormDetailOffsets(form, false);
	}

	/**
	 * If no translation is defined, returns null to get default handling.
	 * @param fontFamily
	 * @return
	 */
	public String getFontTranslation(String fontFamily) {
		//TODO future-compatible accept a list of names (comma+whitespace-separated) may include quotes, too.
		//TODO "arial" is common.
		//TODO "inherit"
		//TODO convert translation with "http" : "-" into "%2d"
		String sans = "default";
		String mono = "VeraMono.ttf";
		String cursive = "Allura.ttf";
		String fantasy = "system";
		String serif = "DroidSerif.ttf";
//		String serif = "http://david.blackledge.com/tivo/enterwebz/DroidSerif";
		
		String translated;
		if (fontFamily == null)
			translated = null;
		else if (fontFamily.equals("sans-serif"))
			translated = sans;
		else if(fontFamily.equals("monospace"))
			translated = mono;
		else if(fontFamily.equals("cursive")) 
			translated = cursive;
		else if(fontFamily.equals("fantasy"))
			translated = fantasy;
		else if(fontFamily.equals("serif"))
			translated = serif;
		else
			translated = null;
		return translated;
	}
}
