package com.blackledge.david.tivo;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedHashMap;

import com.blackledge.david.tivo.V49IHmeProtocol;
import com.tivo.hme.sdk.IHmeProtocol;

/**
 * https://docs.google.com/spreadsheet/ccc?key=0AsOdOJNsln8YdDE0V3IwM2llS2lFa0sweW9Cald6b3c&usp=sharing
 * 
 * http://www.weaknees.com/tivo-peanut-remote.php
 * 
 * @author David
 *
 */
public class TiVoRemoteInfo {
//	/** http://www.weaknees.com/images/tivo_remote/philips_sa.jpg */
//	public static final TiVoRemoteInfo SERIES1_REMOTE = new TiVoRemoteInfo();
//	/** http://www.weaknees.com/images/tivo_remote/s2_sa_tivo2.jpg */
//	public static final TiVoRemoteInfo SERIES2_REMOTE = new TiVoRemoteInfo(SERIES1_REMOTE);
//	static {
//		SERIES2_REMOTE._dvrSwitch = true;
////		SERIES2_REMOTE.setKeyName(V49IHmeProtocol.KEY_TV_INPUT, "TV Input");
//		SERIES2_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_GUIDE, "Guide");
//		SERIES2_REMOTE.setKeyName(V49IHmeProtocol.KEY_DISPLAY, "Display");
//		SERIES2_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ASPECT, "Aspect");
//		SERIES2_REMOTE.setKeyName(V49IHmeProtocol.KEY_ENTER, "Enter/Last");
//	}
//	/** http://www.weaknees.com/images/tivo_remote/humax_s2_sa.jpg */
//	public static final TiVoRemoteInfo SERIES2_SILVER_REMOTE = new TiVoRemoteInfo(SERIES2_REMOTE);
//	static {
//		// humax
//		SERIES2_SILVER_REMOTE.setKeyName(V49IHmeProtocol.KEY_INFO, "Info");
//		SERIES2_SILVER_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_WINDOW, "Window");
//	}
//	/** http://www.weaknees.com/images/tivo_remote/s2-black-full.jpg */
//	public static final TiVoRemoteInfo SERIES2_BLACK_REMOTE = new TiVoRemoteInfo(SERIES2_SILVER_REMOTE);
//	/** http://www.weaknees.com/images/tivo_remote/tivo-hd-remote-large.jpg */
//	public static final TiVoRemoteInfo TIVO_HD_REMOTE = new TiVoRemoteInfo(SERIES2_BLACK_REMOTE);
//	static {
//		TIVO_HD_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ASPECT, "Aspect");
//		TIVO_HD_REMOTE.setKeyName(V49IHmeProtocol.KEY_ADVANCE, "Skip (-)"); // started adding "dash" hint
//	}
//	/** http://www.weaknees.com/images/tivo_remote/s3-black-lg.jpg */
//	public static final TiVoRemoteInfo SERIES3_GLO_REMOTE = new TiVoRemoteInfo(TIVO_HD_REMOTE);
//	static {
//		SERIES3_GLO_REMOTE._learning = true;
////		SERIES3_GLO_REMOTE.setKeyName(V49IHmeProtocol.KEY_TV_INPUT, "Input"
//		SERIES3_GLO_REMOTE.setKeyName(V49IHmeProtocol.KEY_ENTER, "Enter"); // dropped "Last" on this one
//	}
//	/** http://www.weaknees.com/images/tivo_remote/premiere-full-noglo.jpg */
//	public static final TiVoRemoteInfo PREMIERE_REMOTE = new TiVoRemoteInfo(TIVO_HD_REMOTE);
//	static {
//		PREMIERE_REMOTE._dvrSwitch = false;
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_LIVETV,"Live TV / Swap");
////		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_TV_INPUT, "Input");
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ZOOM, "Zoom");
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_CHANNELUP, "Channel Up"); // "page" removed
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_CHANNELDOWN, "Channel Down");
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ACTION_A, "A");
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ACTION_B, "B");
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ACTION_C, "C");
//		PREMIERE_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ACTION_D, "D");
//	}
//	/** http://www.weaknees.com/images/tivo_remote/premiere-remote-lg.jpg */
//	public static final TiVoRemoteInfo PREMIERE_GLO_REMOTE = new TiVoRemoteInfo(PREMIERE_REMOTE);
//	static {
//		PREMIERE_GLO_REMOTE._learning = true;
//	}
//	public static final TiVoRemoteInfo SLIDE_REMOTE = new TiVoRemoteInfo(PREMIERE_REMOTE);
//	static {
//		SLIDE_REMOTE._rf = true;
//		//FIXME learning?? if so, sort-of offshoot of PREMIERE_GLO_REMOTE
//		SLIDE_REMOTE._keyboard = true;
//		// FIXME all keyboard keys
//	}
//	/**  */
//	public static final TiVoRemoteInfo ROAMIO_REMOTE = new TiVoRemoteInfo(PREMIERE_REMOTE);
//	static {
//	}
//	/**  */
//	public static final TiVoRemoteInfo CHARTER_REMOTE = new TiVoRemoteInfo(PREMIERE_REMOTE);
//	static {
//		//TODO check against actual premiere for other differences
//		CHARTER_REMOTE.setKeyName(V49IHmeProtocol.KEY_OPT_ON_DEMAND, "Charter");
//	}
//	
//	//FIXME directv remotes: http://www.weaknees.com/tivo-directv-peanut-remote.php and http://www.weaknees.com/directv-universal-remote.php
//	// at least the tivo-like ones
//	//FIXME dvd remotes: http://www.weaknees.com/tivo-dvd-remote.php and http://www.weaknees.com/toshiba-tivo-remote.php
//	
//	
//	private TiVoRemoteInfo() {
//	_ir = true;
//	_rf = false;
//	_keyboard = false;
//	_learning = false;
//	_dvrSwitch = false;
////	setKeyName(V49IHmeProtocol.KEY_???, "TV Power");
//	setKeyName(V49IHmeProtocol.KEY_LIVETV, "Live TV"); // "Live TV / Guide" on Series 1
//	setKeyName(V49IHmeProtocol.KEY_UP, "Up");
//	setKeyName(V49IHmeProtocol.KEY_DOWN, "Down");
//	setKeyName(V49IHmeProtocol.KEY_LEFT, "Left");
//	setKeyName(V49IHmeProtocol.KEY_RIGHT, "Right");
//	
//	setKeyName(V49IHmeProtocol.KEY_THUMBSDOWN, "Thumbs Down");
//	setKeyName(V49IHmeProtocol.KEY_THUMBSUP, "Thumbs Up");
//	setKeyName(V49IHmeProtocol.KEY_SELECT, "Select");
//	
//	setKeyName(V49IHmeProtocol.KEY_VOLUMEUP, "Volume Up");
//	setKeyName(V49IHmeProtocol.KEY_VOLUMEDOWN, "Volume Down");
//	setKeyName(V49IHmeProtocol.KEY_MUTE, "Mute");
//	setKeyName(V49IHmeProtocol.KEY_RECORD, "Record");
//	setKeyName(V49IHmeProtocol.KEY_CHANNELUP, "Channel (Page) Up");
//	setKeyName(V49IHmeProtocol.KEY_CHANNELDOWN, "Channel (Page) Down");
//	
//	setKeyName(V49IHmeProtocol.KEY_PLAY, "Play");
//	setKeyName(V49IHmeProtocol.KEY_PAUSE, "Pause");
//	setKeyName(V49IHmeProtocol.KEY_REVERSE, "Reverse"); // "Back" on Series 1
//	setKeyName(V49IHmeProtocol.KEY_FORWARD, "Forward");
//	setKeyName(V49IHmeProtocol.KEY_SLOW, "Slow");
//	setKeyName(V49IHmeProtocol.KEY_REPLAY, "Replay");
//	setKeyName(V49IHmeProtocol.KEY_ADVANCE, "Skip");
//	
//	setKeyName(V49IHmeProtocol.KEY_NUM1, "1");
//	setKeyName(V49IHmeProtocol.KEY_NUM2, "2");
//	setKeyName(V49IHmeProtocol.KEY_NUM3, "3");
//	setKeyName(V49IHmeProtocol.KEY_NUM4, "4");
//	setKeyName(V49IHmeProtocol.KEY_NUM5, "5");
//	setKeyName(V49IHmeProtocol.KEY_NUM6, "6");
//	setKeyName(V49IHmeProtocol.KEY_NUM7, "7");
//	setKeyName(V49IHmeProtocol.KEY_NUM8, "8");
//	setKeyName(V49IHmeProtocol.KEY_NUM9, "9");
//	setKeyName(V49IHmeProtocol.KEY_NUM0, "0");
//	setKeyName(V49IHmeProtocol.KEY_CLEAR, "Clear");
//	setKeyName(V49IHmeProtocol.KEY_ENTER, "Enter");
//}

	
	
	private HashMap<Integer, String> _keyNames = new HashMap<Integer, String>();
	private HashMap<Integer, String> _keyIcons = new HashMap<Integer, String>();
	private String _id;
	private String _name;
	
	private String _derivation;
	
	private boolean _ir;
	private boolean _rf;
	private boolean _keyboard;
	private boolean _learning;
	private boolean _dvrSwitch;
	private boolean _glow;
	
	private URL _image;
	
	/** does not copy id, name, or image */
	protected TiVoRemoteInfo(TiVoRemoteInfo copyme) {
		this();
		if(copyme == null)
			return;

		_derivation = copyme._id;
		
		_keyNames.putAll(copyme._keyNames);
		_keyIcons.putAll(copyme._keyIcons);
		_ir = copyme._ir;
		_rf = copyme._rf;
		_keyboard = copyme._keyboard;
		_learning = copyme._learning;
		_dvrSwitch = copyme._dvrSwitch;
		_glow = copyme._glow;
	}
	
	private TiVoRemoteInfo() {
	}

	private final static String remotesFilename = "com/blackledge/david/tivo/TiVo Remote Information - Sheet1.csv";
	private final static HashMap<String, TiVoRemoteInfo> remotes = new LinkedHashMap<String, TiVoRemoteInfo>();
	
	public static synchronized TiVoRemoteInfo getRemote(String remote_id) {
//		System.out.println("getting for "+tsn);
		if(remotes.size() == 0) {
			InputStream fileStream = TiVoRemoteInfo.class.getClassLoader().getResourceAsStream(remotesFilename);
			if(fileStream == null) {
				errorOut(remotesFilename+" file failed");
				return null;
			}
			BufferedReader reader = new BufferedReader(new InputStreamReader(fileStream));
			try {
				HashMap<Integer, Integer> keyFieldCode = new HashMap<Integer, Integer>();
				int keyStartIndex = -1;
				
				for (String line = reader.readLine(); line != null; line = reader.readLine()) {
					if(line.trim().length() == 0) continue;

					if(line.startsWith(",,")) continue;
					
					String[] fields = line.split(",");
					// fix the array to account for quoted fields with commas inside.
					fields = fixCSVFields(fields);
					
					//#ID	name	ir	rf	keyboard	learning	dvrSwitch	glow	derivation id	Image	KEY_TIVO	KEY_LIVETV	KEY_UP	KEY_DOWN	KEY_LEFT	KEY_RIGHT	KEY_THUMBSDOWN	KEY_THUMBSUP	KEY_SELECT	KEY_VOLUMEUP	KEY_VOLUMEDOWN	KEY_MUTE	KEY_RECORD	KEY_CHANNELUP	KEY_CHANNELDOWN	KEY_PLAY	KEY_PAUSE	KEY_REVERSE	KEY_FORWARD	KEY_SLOW	KEY_REPLAY	KEY_ADVANCE	KEY_NUM1	KEY_NUM2	KEY_NUM3	KEY_NUM4	KEY_NUM5	KEY_NUM6	KEY_NUM7	KEY_NUM8	KEY_NUM9	KEY_NUM0	KEY_CLEAR	KEY_ENTER	KEY_TV_POWER	KEY_TV_INPUT	KEY_OPT_GUIDE	KEY_INFO	KEY_OPT_ASPECT	KEY_OPT_LIST	KEY_OPT_EXIT	KEY_OPT_ACTION_A	KEY_OPT_ACTION_B	KEY_OPT_ACTION_C	KEY_OPT_ACTION_D	KEY_OPT_BACK	KEY_OPT_ON_DEMAND	KEY_OPT_DVD	KEY_OPT_ANGLE	KEY_OPT_TOP_MENU	KEY_OPT_MENU	KEY_OPT_STOP	KEY_OPT_RETURN	KEY_OPT_VCR_PLUS	KEY_OPT_ACTIVE	KEY_OPT_SEARCH	KEY_OPT_TEXT	KEY_OPT_CC					
					if(line.startsWith("#")){
						for(int i = 0 ; i < fields.length ; ++i) {
							if(fields[i].startsWith("KEY_")) {
								if(keyStartIndex < 0) {
									keyStartIndex = i;
								}
								keyFieldCode.put(i, getKeyCode(fields[i]));
							}
						}
						continue;
					}
					
//					System.out.println(fields.length+" - "+line);
					if(fields.length < 8) continue;
					
					try {
						int index;
						
						String derivation_name = fields[8];
						TiVoRemoteInfo derivation = null;
						if(derivation_name != null)
							derivation = remotes.get(derivation_name);
						TiVoRemoteInfo remote = new TiVoRemoteInfo(derivation);

						index = 0;
						if(fields[index] != null)
							remote._id = fields[index].trim();

						index = 1;
						if(fields[index] != null)
							remote._name = fields[index];						
						
						index = 2;
						try {
							if(fields[index] != null)
								remote._ir = Boolean.parseBoolean(fields[index]);
						} catch(Exception e) {
						}
						
						index = 3;
						try {
							if(fields[index] != null)
								remote._rf = Boolean.parseBoolean(fields[index]);
						} catch(Exception e) {
						}
						
						index = 4;
						try {
							if(fields[index] != null)
								remote._keyboard = Boolean.parseBoolean(fields[index]);
						} catch(Exception e) {
						}
						
						index = 5;
						try {
							if(fields[index] != null)
								remote._learning = Boolean.parseBoolean(fields[index]);
						} catch(Exception e) {
						}
						
						index = 6;
						try {
							if(fields[index] != null)
								remote._dvrSwitch = Boolean.parseBoolean(fields[index]);
						} catch(Exception e) {
						}
						
						index = 7;
						try {
							if(fields[index] != null)
								remote._glow = Boolean.parseBoolean(fields[index]);
						} catch(Exception e) {
						}

						// 8 already done
						
						index = 9;
						try {
							if(fields[index] != null)
								remote._image = new URL(fields[index]);
						} catch(Exception e) {
						}

						// load keys
						for(int i = keyStartIndex ; i < fields.length ; ++i) {
							Integer keyCode = keyFieldCode.get(i);
							String label = null;
							String icon = null;
							if(fields[i] != null) {
								label = fields[i];
								int sep = label.indexOf('|');
								if(sep > -1) {
									icon = label.substring(sep+1);
									if(sep == 0) {
										label = "";
									} else {
										label = label.substring(0, sep);
									}
								}
							}
							if(keyCode != -1) {
								if(label != null) {
									remote.setKeyName(keyCode, label.trim());
								}
								if(icon != null) {
									remote.setKeyIcon(keyCode, icon.trim());
								}
							}
						}
						
						// save remote
						remotes.put(remote._id, remote);

					} catch(Exception e) {
//						errorOut(e);
						continue;
					}
				}
			} catch (IOException e) {
				errorOut(e);
				return null;
			}
		}
		
		try {
			TiVoRemoteInfo model = remotes.get(remote_id);
			return model;
		} catch (Exception e) {
			return null;
		}
	}
	
	protected static void errorOut(Object o) {
		System.err.println(o);
	}
	
	@Override
	public String toString() {
		return _id+":"+_name;//+":"+_keyNames.get(IHmeProtocol.KEY_ADVANCE)+":"+_keyNames.get(IHmeProtocol.KEY_OPT_ASPECT);
	}

	private static String[] fixCSVFields(String[] fields) {
		String fixed_fields[] = new String[fields.length];
		int i1 = 0;
		int j = 0;
		while(i1 < fields.length) {
			String nextField = nextField(fields, i1);
			fixed_fields[j++] = nextField;
			i1 += 1 + (commaCount(nextField));
		}
		int fixed_length = j;
		fields = Arrays.copyOf(fixed_fields, fixed_length);
		return fields;
	}

	/** handle quote "escaping" of fields with commas*/
	protected static String nextField(String[] fields, int i) {
		while (fields.length > i && fields[i].length() > 0) {
			String result = fields[i];
			if (result.startsWith("\"")) {
				while ((!result.endsWith("\"\"\"") && 
						(result.endsWith("\"\"") || !result.endsWith("\"")))
						&& fields.length > i + 1) {
					++i;
					result += "," + fields[i];
				}
				result = result.substring(1, result.length()-1);
				result = result.replace("\"\"", "\"");
			}
			return result;
		}
		return null;
	}

	protected static int commaCount(String nextField) {
		if(nextField == null) return 0;
		int i = 0;
		int index = nextField.indexOf(',');
		while(index >= 0)
		{
			++i;
			index = nextField.indexOf(',',index+1);
		}
		return i;
	}

	public static void main(String[] args) {
		TiVoRemoteInfo remote = getRemote("BASE");
		System.out.println("------------");
		if(remote != null) {
			System.out.println(remote.getKeyName(IHmeProtocol.KEY_ADVANCE));
			System.out.println(remote.getKeyIcon(IHmeProtocol.KEY_ADVANCE));
			System.out.println(remote.getKeyName(IHmeProtocol.KEY_ENTER));
			System.out.println(remote.getKeyIcon(IHmeProtocol.KEY_ENTER));
			System.out.println(remote.getKeyName(IHmeProtocol.KEY_OPT_ASPECT));
			System.out.println(remote.getKeyIcon(IHmeProtocol.KEY_OPT_ASPECT));
		}
		remote = getRemote("PREMIERE_REMOTE");		System.out.println("------------");
		if(remote != null) {
			System.out.println(remote.getKeyName(IHmeProtocol.KEY_ADVANCE));
			System.out.println(remote.getKeyIcon(IHmeProtocol.KEY_ADVANCE));
			System.out.println(remote.getKeyName(IHmeProtocol.KEY_ENTER));
			System.out.println(remote.getKeyIcon(IHmeProtocol.KEY_ENTER));
			System.out.println(remote.getKeyName(IHmeProtocol.KEY_OPT_ASPECT));
			System.out.println(remote.getKeyIcon(IHmeProtocol.KEY_OPT_ASPECT));
		}
	}
	
	protected void setKeyName(int keyCode, String name) {
		_keyNames.put(keyCode, name);
	}
	
	protected void setKeyIcon(int keyCode, String icon) {
		_keyIcons.put(keyCode, icon);
	}

	/**
	 * Returns the remote's name the button. If the {@link #hasKeyboard()}, for
	 * ASCII keys between {@link V49IHmeProtocol#KEY_OPT_ASCII_START} and
	 * {@link V49IHmeProtocol#KEY_OPT_ASCII_END}, returns a string containing
	 * that single ASCII character.
	 * 
	 * @param keyCode
	 * @return
	 */
	public String getKeyName(int keyCode) {
		if (_keyboard) {
			if (keyCode >= V49IHmeProtocol.KEY_OPT_ASCII_START
					&& keyCode <= V49IHmeProtocol.KEY_OPT_ASCII_END) {
				return String.valueOf((char) (keyCode - V49IHmeProtocol.KEY_OPT_ASCII_START));
			}
		}
		return _keyNames.get(keyCode);
	}
	
	public String getKeyIcon(int keyCode) {
		return _keyIcons.get(keyCode);
	}
	
	public boolean isKeyPresent(int keyCode) {
		if(keyCode >= V49IHmeProtocol.KEY_OPT_ASCII_START && keyCode <= V49IHmeProtocol.KEY_OPT_ASCII_END) {
			return _keyboard;
		}
		//TODO  other non-ascii keycodes on keyboard?
		
		return (getKeyName(keyCode) != null || getKeyIcon(keyCode) != null);
	}
	
	public boolean isIR() {
		return _ir;
	}
	
	public boolean isRF() {
		return _rf;
	}
	
	public boolean hasKeyboard() {
		return _keyboard;
	}
	
	public boolean isLearning() {
		return _learning;
	}
	
	public boolean isBacklit() {
		return _glow;
	}
	
	public URL getImage() {
		return _image;
	}
	
	public String getName() {
		if(_name == null) {
			return _id;
		}
		return _name;
	}
	
	public String getID() {
		return _id;
	}

	public static int getKeyCode(String keyCodeName) {
			for(Field field : IHmeProtocol.class.getFields()) {
				try {
					if (Modifier.isStatic(field.getModifiers())
							&& field.getName().equals(keyCodeName)) {
						return field.getInt(null);
					}
				} catch (IllegalArgumentException e) {
//					e.printStackTrace();
				} catch (IllegalAccessException e) {
//					e.printStackTrace();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			for(Field field : V49IHmeProtocol.class.getFields()) {
				try {
					if (Modifier.isStatic(field.getModifiers())
							&& field.getName().equals(keyCodeName)) {
						return field.getInt(null);
					}
				} catch (IllegalArgumentException e) {
//					e.printStackTrace();
				} catch (IllegalAccessException e) {
//					e.printStackTrace();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			return -1;
	}
	
	/**
	 * gets the PREMIERE_REMOTE or the last defined remote.
	 */
	public static TiVoRemoteInfo getDefaultRemote() {
		TiVoRemoteInfo result = getRemote("PREMIERE_REMOTE");
		if(result == null && remotes.size() > 0) {
			// get the last remote as a last resort.
			Object[] keys = remotes.keySet().toArray();
			Object key = keys[keys.length-1];
			result = remotes.get(key);
		}
		return result;
	}

	/**
	 * All remotes (less the "BASE" remote).
	 */
	public static Collection<TiVoRemoteInfo> getRemotes() {
		ArrayList<TiVoRemoteInfo> result = new ArrayList<TiVoRemoteInfo>(remotes.values());
		result.remove(remotes.get("BASE"));
		return result;
	}

}
