package com.blackledge.david.tivo;

import com.tivo.hme.interfaces.IContext;
import com.tivo.hme.sdk.Application;
import com.tivo.hme.sdk.HmeEvent;
import com.tivo.hme.sdk.StreamResource;
import com.tivo.hme.sdk.View;
import com.tivo.hme.sdk.HmeEvent.ResourceInfo;

public class VidTest extends Application {
	
	private View text;
	private String font;


	@Override
	public void init(IContext context) throws Exception {
		super.init(context);
		
//        self.textbg = hme.View(self, height=60, colornum=0x7f7f7f)
		View textbg = new View(getRoot(), 0, 0, getRoot().getWidth(), 60);
		textbg.setResource("0x7f7f7f");
//        self.font = hme.Font(self.app, size=16)
		font = "default-16.font";
//        self.text = self.textbg.child()
		text = new View(textbg, 0, 0, textbg.getWidth(), textbg.getHeight());
//        self.text.set_text("LOADING...", colornum=0xff, font=self.font)
		text.setResource(text.createText(font, "0x0000ff", "LOADING..."));
//        
//        vidfile = "C:/Users/David/Desktop/CC517_commodore_64.mpeg"
//        url = 'http://'+ self.context.headers['host'] + vidfile.replace("c:", "")
//        url = 'http://ia600504.us.archive.org/19/items/CC517_commodore_64/CC517_commodore_64.mpeg'
		String url = "http://ia600504.us.archive.org/19/items/CC517_commodore_64/CC517_commodore_64.mpeg";
		StreamResource stream = createStream(url);
//        self.stream = hme.Stream(self, url)
		getRoot().setResource(stream);
//        self.root.set_resource(self.stream)
//        #self.active = False
		
		
	}
	
	@Override
	public boolean handleIdle(boolean isIdle) {
		acknowledgeIdle(true);
		return true;
	}

	
	@Override
	public boolean handleEvent(HmeEvent event) {
		if(event.getOpCode() == EVT_RSRC_INFO)
		{
			ResourceInfo ev = (ResourceInfo) event;
//			   if status >= hme.RSRC_STATUS_PLAYING:
			if(ev.getStatus() >= RSRC_STATUS_PLAYING) {
//		            if 'position' in info:
				if(ev.getMap().containsKey("position")) {
//		                position = float(info['position'])/(1000*60)
					float position = Float.parseFloat(String.valueOf(ev.getMap().get("position")))/(1000*60);
//		                duration = float(info['duration'])/(1000*60)
					float duration = Float.parseFloat(String.valueOf(ev.getMap().get("duration")))/(1000*60);
//		                pos = "%.1f" % (position)
					String pos = String.format("%.1f", position);
//		                dur = "%.1f" % (duration)
					String dur = String.format("%.1f", duration);
//		                self.text.set_text(
					text.setResource(text.createText(font, "0x0000ff", 
		                   "INFO (minutes): position=" + pos + " duration=" + dur
		                   ));
//		                   colornum=0xff, font=self.font
//		                )
				}
				return true;
			}
		}
		// TODO Auto-generated method stub
		return super.handleEvent(event);
	}
}
