package com.blackledge.david.tivo.game;

import com.blackledge.david.game.MultiplayerGameBase;
import com.blackledge.david.game.PlayerState;

public class TestGameServer extends MultiplayerGameBase {
	public static final int TEST_ACTION=1;
	public static final int TEST_VALUE_1=1;
	public static final int TEST_VALUE_2=2;
	@Override
	protected boolean playerAction(GameData game,
			PlayerState player, int action, Object details) {
		if(player.hasTurn) {
			if(action == TEST_ACTION) {
				if(game.players.indexOf(player)==0)
					game.boardState.set(0, 0, TEST_VALUE_1);
				else
					game.boardState.set(0, 0, TEST_VALUE_2);
				
				nextTurn(game, player);
				
				// both board and player states have changed
				return true;
			}
		}
		return false;
	}


	@Override
	public int getBoardHeight() {
		return 1;
	}
	@Override
	public int getBoardWidth() {
		return 1;
	}


	private static TestGameServer _instance = null;
	public static synchronized TestGameServer getInstance() {
		if(_instance == null) {
			_instance = new TestGameServer();
		}
		return _instance;
	}


	public boolean isComputerPlayerAvailable() {
		// TODO Auto-generated method stub
		return false;
	}
	


}
